# =============================================================
#               CodeTyphon Studio
#      Copyright (c) PilotLogic Software House.
#               All rights reserved.
#
#      This Script Install to Mageia Linux 
#      base libraries to Build and Run CodeTyphon
# =============================================================
# Update (15-5-2014) for Mageia 4 64 (Mageia-4-x86_64-DVD.iso) MultiArch for GTK2 and QT4
# Update (28-6-2014) for Mageia 5 64 (Mageia-5-x86_64-DVD.iso) MultiArch for GTK2, QT4 and QT5
# Update (16-7-2017) for Mageia 6 64 (Mageia-6-x86_64-DVD.iso) MultiArch for GTK2 and QT4 (Has Old QT5 5.6.2 < 5.7)
# Update (07-10-2018) for Mageia 6.1 64bits (MultiPatform)
# Update (02-07-2019) for Mageia 7.0 64bits (MultiPatform)


ciplatiform=$1
cicpubits=$2
cicpuname=$3
ciUseMultiArch=$4

#========================================================


echo "----------------------------------------------------"
echo " CodeTyphon OS Libraries Installation for" 
echo "               Mageia Linux" 
echo "----------------------------------------------------"
echo "   "
echo "[INFO] Start OS Update..."
echo "   "
sudo urpmi --auto-update

echo "   "
echo "[INFO] Start Libraries Installation..."
echo "   "

sudo urpmi --auto -a xterm
sudo urpmi --auto -a zip
sudo urpmi --auto -a unzip
sudo urpmi --auto -a wget

sudo urpmi --auto -a make 
sudo urpmi --auto -a gcc
sudo urpmi --auto -a gcc-c++
sudo urpmi --auto -a gdb 
sudo urpmi --auto -a binutils

sudo urpmi --auto -a glibc-devel 
sudo urpmi --auto -a libx11-devel
sudo urpmi --auto -a libxtst
sudo urpmi --auto -a libxtst-devel
sudo urpmi --auto -a mesa-common-devel

if [ $cicpubits = 64 ] ; then
   sudo urpmi --auto -a lib64mesaglu1
fi
   sudo urpmi --auto -a libmesaglu1

sudo urpmi --auto -a freetype2

sudo urpmi --auto -a xorg-x11-100dpi-fonts xorg-x11-75dpi-fonts 

# Install libraries for GTK2
if [ $ciplatiform = 0 ] ; 
then

   if [ $cicpubits = 64 ] ; then
     sudo urpmi --auto -a lib64atk1.0_0
   fi

     sudo urpmi --auto -a libatk1.0_0
    
   if [ $ciUseMultiArch = 1 ] ; 
   then   
     sudo urpmi --auto -a gtk2
     sudo urpmi --auto -a cairo
     sudo urpmi --auto -a pango 
   else  
     sudo urpmi --auto -a gtk2-devel
     sudo urpmi --auto -a cairo-devel 
     sudo urpmi --auto -a pango-devel 
   fi 

fi

# Install libraries for QT4
if [ $ciplatiform = 1 ] ; 
then
    echo "   "
    echo "[INFO] Install libraries for QT4"
    echo "   "
    sudo urpmi --auto -a qt4-devel

    if [ $cicpubits = 64 ] ; then
     sudo urpmi --auto -a lib64qt4-devel
     sudo urpmi --auto -a lib64qtwebkit2.2_4
    fi
    sudo urpmi --auto -a libqt4-devel
    sudo urpmi --auto -a libqtwebkit2.2_4

    sudo urpmi --auto -a qtwebkit-devel
fi

# Install libraries for GTK3
if [ $ciplatiform = 3 ] ; 
then
    echo "   "
    echo "[INFO] Install libraries for GTK3"
    echo "   "
    sudo urpmi --auto -a gtk+-3.0   
fi

# Install libraries for QT5
if [ $ciplatiform = 7 ] ; 
 then
    echo "   "
    echo "[INFO] Install libraries for QT5"
    echo "   "

    if [ $cicpubits = 64 ] ; then
     sudo urpmi --auto -a lib64qt5core-devel
     sudo urpmi --auto -a lib64qt5gui5
     sudo urpmi --auto -a lib64qt5webkit5
     sudo urpmi --auto -a lib64qt5widgets5
     sudo urpmi --auto -a lib64qt5network5
     sudo urpmi --auto -a lib64qt5webkitwidgets5
     sudo urpmi --auto -a lib64qt5webkit-devel 
     sudo urpmi --auto -a libqt5x11extras-devel
    fi

    sudo urpmi --auto -a libqt5core
    sudo urpmi --auto -a libqt5gui5
    sudo urpmi --auto -a libqt5webkit5
    sudo urpmi --auto -a libqt5widgets5
    sudo urpmi --auto -a libqt5network5
    sudo urpmi --auto -a libqt5webkitwidgets5
    sudo urpmi --auto -a libqt5webkit
    sudo urpmi --auto -a libqt5x11extras5


fi

#========================================================

echo "----------------------------------------------------"
echo "CodeTyphon OS Libraries Installation"  
echo "Finish !!!"

#sleep 5