# =============================================================
#               CodeTyphon Studio
#      Copyright (c) PilotLogic Software House.
#               All rights reserved.
#
#     This Script Install to NetBSD OS
#     base libraries to Build and Run CodeTyphon
# =============================================================
# Update 17-07-2015 for NetBSD 6.1.5
# Update 20-05-2019 for NetBSD 8.0
# Update 24-08-2019 for NetBSD 8.1


ciplatiform=$1
cicpubits=$2
cicpuname=$3
ciUseMultiArch=$4

#========================================================

echo "----------------------------------------------------"
echo " CodeTyphon OS Libraries Installation for" 
echo "                NetBSD" 
echo "----------------------------------------------------"
echo "   "

# export PKG_PATH="http://ftp.netbsd.org/pub/pkgsrc/packages/NetBSD/$(machine -a)/$(uname -r)/All/"
# It's usually a good idea to add a line similar to the above to your ~/.profile

sudo pkgin -y install xterm
sudo pkgin -y install zip 
sudo pkgin -y install unzip
sudo pkgin -y install wget

sudo pkgin -y install gmake 

case $(uname -r) in
 7.*)
  sudo pkgin -y install gcc
  sudo pkgin -y install gdb
 ;;
 8.*)
  sudo pkgin -y install gcc8
  sudo pkgin -y install gdb-8
 ;;
 *)
  sudo pkgin -y install gcc8
  sudo pkgin -y install gdb-8
 ;; 
esac

sudo pkgin -y install binutils 
sudo pkgin -y install gmake

sudo pkgin -y install libiconv 
sudo pkgin -y install libX11 
sudo pkgin -y install libXtst

#sudo pkgin -y install xorg-fonts-type1
#sudo pkgin -y install takao-fonts-ttf

# Install libraries for GTK2
if [ $ciplatiform = 0 ] ; 
then
    echo "   "
    echo "[INFO] Install libraries for GTK2"
    echo "   "
    sudo pkgin -y install gtkglext  
fi

# Install libraries for QT4
if [ $ciplatiform = 1 ] ; 
then
    echo "   "
    echo "[INFO] Install libraries for QT4"
    echo "   "
    sudo pkgin -y install libqt4-dev 
    sudo pkgin -y install qt4-qmake    
fi

# Install libraries for GTK3
if [ $ciplatiform = 3 ] ; 
then
    echo "   "
    echo "[INFO] Install libraries for GTK3"
    echo "   "
    sudo pkgin -y install gtk+-3.0   
fi

# Install libraries for QT5
if [ $ciplatiform = 7 ] ; 
 then
    echo "   "
    echo "[INFO] Install libraries for QT5"
    echo "   "
    sudo pkgin -y install libqt5-dev 
    sudo pkg install -y qt5-x11extras
    sudo pkgin -y install qt5-qmake   
fi


echo "----------------------------------------------------"
echo "CodeTyphon OS Libraries Installation"  
echo "Finish !!!"

#sleep 5
