# =============================================================
#               CodeTyphon Studio
#      Copyright (c) PilotLogic Software House.
#               All rights reserved.
#
#     This Script Install to RedHat Linux
#     base libraries to Build and Run CodeTyphon 
# =============================================================
# Update 06-02-2016 for Scientific Linux 7.2 (MultiArch for GTK2, QT4 and QT5)
# Update 12-05-2018 for Scientific Linux 7.5


ciplatiform=$1
cicpubits=$2
cicpuname=$3
ciUseMultiArch=$4

#========================================================

echo "----------------------------------------------------"
echo " CodeTyphon OS Libraries Installation for" 
echo "              RedHat Linux" 
echo "----------------------------------------------------"
echo "   "

echo "[INFO] Start OS Update..."
echo "   "
sudo yum update -y 

echo "   "
echo "[INFO] Start Libraries Installation..."
echo "   "

sudo yum install -y xterm 
sudo yum install -y zip 
sudo yum install -y unzip
sudo yum install -y wget

sudo yum install -y make 
sudo yum install -y kernel-devel 
sudo yum install -y kernel-headers 
sudo yum install -y gcc 
sudo yum install -y gcc-c++
sudo yum install -y gdb 
sudo yum install -y binutils 

sudo yum install -y glib-devel 
sudo yum install -y glibc-devel 
sudo yum install -y libX11-devel
sudo yum install -y libXtst
sudo yum install -y libXtst-devel
sudo yum install -y mesa-libGLU 
sudo yum install -y libGL* 
sudo yum install -y freeglut 
sudo yum install -y xorg-x11-font*

if [ $ciUseMultiArch = 1 ] ; 
then
  sudo yum install -y glib-devel.i686  
  sudo yum install -y glibc-devel.i686  
  sudo yum install -y libX11-devel.i686 
  sudo yum install -y libXtst.i686 
  sudo yum install -y libXtst-devel.i686 
  sudo yum install -y mesa-libGLU.i686  
  sudo yum install -y freeglut.i686   
fi

# Install libraries for GTK2
if [ $ciplatiform = 0 ] ; 
then
    echo "   "
    echo "[INFO] Install libraries for GTK2"
    echo "   "
    sudo yum install -y gtk2-devel 
    sudo yum install -y gtk+extra 
    sudo yum install -y gtk+-devel
    sudo yum install -y cairo-devel 
    sudo yum install -y cairo-gobject-devel
    sudo yum install -y pango-devel 

       
    if [ $ciUseMultiArch = 1 ] ; 
    then
      sudo yum install -y gtk2-devel.i686 
      sudo yum install -y gtk+extra.i686  
      sudo yum install -y gtk+-devel.i686 
      sudo yum install -y cairo-devel.i686  
      sudo yum install -y cairo-gobject-devel.i686 
      sudo yum install -y pango-devel.i686  
    fi   

fi

# Install libraries for QT4
if [ $ciplatiform = 1 ] ; 
then
    echo "   "
    echo "[INFO] Install libraries for QT4"
    echo "   "
            
    sudo yum install -y qt-devel
    sudo yum install -y qt-config  
    sudo yum install -y qt4-devel  
    sudo yum install -y qtwebkit.x86_64

    if [ $ciUseMultiArch = 1 ] ; 
    then
      sudo yum install -y qt-devel.i686 
      sudo yum install -y qtwebkit.i686   
    fi

fi

# Install libraries for GTK3
if [ $ciplatiform = 3 ] ; 
then
    echo "   "
    echo "[INFO] Install libraries for GTK3"
    echo "   "
    sudo yum install -y gtk+-3.0  

    if [ $ciUseMultiArch = 1 ] ; 
    then
     sudo yum install -y gtk+-3.0.i686  
    fi 
fi

# Install libraries for QT5
if [ $ciplatiform = 7 ] ; 
 then
    echo "   "
    echo "[INFO] Install libraries for QT5"
    echo "   "
    sudo yum install -y qt5-qtbase
    sudo yum install -y qt5-qtbase-devel
    sudo yum install -y qt5-qtx11extras
    sudo yum install -y qt5-qtx11extras-devel
  

    if [ $ciUseMultiArch = 1 ] ; 
    then
      sudo yum install -y qt5-qtbase.i686
      sudo yum install -y qt5-qtbase-devel.i686 
      sudo yum install -y qt5-qtx11extras.i686 
      sudo yum install -y qt5-qtx11extras-devel.i686 
    fi
fi
   
echo "----------------------------------------------------"
echo "CodeTyphon OS Libraries Installation" 
echo "Finish !!!"

#sleep 5